<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="属性名称" prop="stockName">
              <el-input v-model="queryParams.stockName" placeholder="请输入属性名称" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="22"><span>商品备货属性信息列表</span> </el-col>
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['system:comCurrency:add']">新增</el-button>
          </el-col>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="stockUpList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="属性编号" align="center" prop="stockNo" />
        <el-table-column label="属性名称" align="center" prop="stockName" />
        <el-table-column label="是否显示" align="center" prop="isShow">
          <template #default="scope">
            <el-switch v-model="scope.row.isShow" active-value="0" inactive-value="1" @change="handleStatusChange(scope.row)"></el-switch>
          </template>
        </el-table-column>
        <el-table-column label="备注" align="center" prop="remark" />
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:stockUp:edit']">编辑</el-button>
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['system:stockUp:remove']">删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改商品备货属性对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="stockUpFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="属性名称" prop="stockName">
          <el-input v-model="form.stockName" placeholder="请输入属性名称" />
        </el-form-item>
        <el-form-item label="是否显示" prop="isShow">
          <el-radio-group v-model="form.isShow">
            <el-radio v-for="dict in sys_platform_yes_no" :key="dict.value" :value="dict.value">{{ dict.label }}</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="StockUp" lang="ts">
import { listStockUp, getStockUp, delStockUp, addStockUp, updateStockUp, changeStatus } from '@/api/product/stockUp';
import { StockUpVO, StockUpQuery, StockUpForm } from '@/api/product/stockUp/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const { sys_platform_yes_no } = toRefs<any>(proxy?.useDict('sys_platform_yes_no'));

const stockUpList = ref<StockUpVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const stockUpFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: StockUpForm = {
  id: undefined,
  stockNo: undefined,
  stockName: undefined,
  isShow: '0',
  dataSource: undefined,
  status: undefined,
  remark: undefined
};
const data = reactive<PageData<StockUpForm, StockUpQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    stockNo: undefined,
    stockName: undefined,
    isShow: undefined,
    dataSource: undefined,
    status: undefined,
    platformCode: undefined,
    params: {}
  },
  rules: {
    stockName: [{ required: true, message: '属性名称不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询商品备货属性列表 */
const getList = async () => {
  loading.value = true;
  const res = await listStockUp(queryParams.value);
  stockUpList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  stockUpFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};
const handleStatusChange = async (row: StockUpVO) => {
  const oldValue = row.isShow; // 保存旧值（0 或 1）

  try {
    await changeStatus(row.id, row.isShow); // 传新值
    proxy?.$modal.msgSuccess('操作成功');
  } catch {
    row.isShow = oldValue; // 失败回滚
    proxy?.$modal.msgError('操作失败，请重试');
  }
};
/** 多选框选中数据 */
const handleSelectionChange = (selection: StockUpVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加商品备货属性';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: StockUpVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getStockUp(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改商品备货属性';
};

/** 提交按钮 */
const submitForm = () => {
  stockUpFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateStockUp(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addStockUp(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: StockUpVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除商品备货属性编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delStockUp(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'system/stockUp/export',
    {
      ...queryParams.value
    },
    `stockUp_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
});
</script>
